#!/usr/bin/perl

#####################################################################################
#
# MIDI-jukebox for the WWW V 1.0
# Perl programming 1997 by Peter Hellmann - all rights reserved -
# http://www.w-4.de/~hellmann
# mailto:hellmann@w-4.de
#
#####################################################################################
#
# please edit only the following variables:
#
# the first line of this file must be set to your Perl path ( example: #!/usr/bin/perl )
#
# $soundcorner ( the name of your html-file including full path )
# !!!!!!! this must be a PHYSICAL PATH !!!!!! NO URL !!!!!!!!!!!!!!!!!!!!!
# $midisonglist ( the name of your songlist-file including full path )
# !!!!!!! this must be a PHYSICAL PATH !!!!!! NO URL !!!!!!!!!!!!!!!!!!!!!
#
#####################################################################################
# name of HTML-file
$soundcorner = "/home/hellmann/www/sound.html";

# set path of MIDI-songlist-file
$midisonglist = "/home/hellmann/www/midi-songs.txt";
#####################################################################################

# open the MIDI-songfile and get songs
open (FILE,"$midisonglist") || die "Can't Open $midisonglist: $!\n";
@LINES=<FILE>;
close(FILE);
$SIZE=@LINES;

# Get the input as POST-Method
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
# Split the name-value pairs
@pairs = split(/&/, $buffer);
foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);
   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;
   $FORM{$name} = $value;
}

# save posted data cause its the actual song key
$song = $FORM{"song"};

# make combobox
for ($i=0;$i<=$SIZE;$i++)
	{
	# get the line
   	$midisong = $LINES[$i];
	# get MIDI-file, Image, Title, Autor
	($key,$midifile,$cover,$title,$autor) = split(/;/, $midisong);
	if ($key eq $song)
		 {
		 $selected = "selected";
		 # save actual selected song  
		 $selection = $midisong;
		 }
 	else 	 {
 		 $selected = "";
		 }
	if ($key) { $combobox .= qq!<option $selected value="$key">$title</option>\n!; }
	}

# get actual MIDI-file, Image, Title, Autor out of actual selected song
($key,$midifile,$cover,$title,$autor) = split(/;/, $selection);

# open HTML-file and get its content
open (FILE,"$soundcorner") || die "Can't Open $soundcorner: $!\n";
$size = -s $soundcorner;
read(FILE, $content, $size);

# replace the html-comment-tags with real values

# set MIDI-file
$a = "<!--the_midi_file-->";
$b = $midifile;
$content =~ s/$a/$b/;

# set title
$a = "<!--the_title-->";
$b = $title;
$content =~ s/$a/$b/;

# set autor
$a = "<!--the_autor-->";
$b = $autor;
$content =~ s/$a/$b/;

# set cover
$a = "<!--the_cover-->";
$b = $cover;
$content =~ s/$a/$b/;

# insert combo-box of MIDI-files
$a = "<!--the_combobox-->";
$b = $combobox;
$content =~ s/$a/$b/;

# send the stuff to the browser
print "Content-type: text/html\n\n";
print $content;

exit;
